This patch lets Abiword 1.0.7 compile on Fedora Core three.  Alas, the
program won't run yet (font problems).

Rant: The GCC developers have no business breaking perfectly good code
that compiled as recently as three years ago.

diff -ur abiword-1.0.7/abi/src/af/util/xp/ut_bijection.cpp abiword-1.0.7.fixed/abi/src/af/util/xp/ut_bijection.cpp
--- abiword-1.0.7/abi/src/af/util/xp/ut_bijection.cpp	2001-05-20 14:56:02.000000000 -0700
+++ abiword-1.0.7.fixed/abi/src/af/util/xp/ut_bijection.cpp	2005-03-05 02:07:21.000000000 -0800
@@ -11,7 +11,7 @@
 {
     m_n = 0;
     m_first = m_second = NULL;
-};
+}
 
 void UT_Bijection::clear()
 {
diff -ur abiword-1.0.7/abi/src/af/util/xp/ut_iconv.cpp abiword-1.0.7.fixed/abi/src/af/util/xp/ut_iconv.cpp
--- abiword-1.0.7/abi/src/af/util/xp/ut_iconv.cpp	2002-04-24 12:49:23.000000000 -0700
+++ abiword-1.0.7.fixed/abi/src/af/util/xp/ut_iconv.cpp	2005-03-05 02:10:14.000000000 -0800
@@ -176,7 +176,7 @@
     // http://www.abisource.com/mailinglists/abiword-dev/01/April/0135.html
     if (XAP_EncodingManager::get_instance()->cjk_locale())
 		UT_iconv(cd, NULL, NULL, NULL, NULL);
-};
+}
 
 /*!
  * Borrowed from GLib 2.0 and modified
diff -ur abiword-1.0.7/abi/src/af/util/xp/ut_mbtowc.cpp abiword-1.0.7.fixed/abi/src/af/util/xp/ut_mbtowc.cpp
--- abiword-1.0.7/abi/src/af/util/xp/ut_mbtowc.cpp	2001-08-10 11:32:38.000000000 -0700
+++ abiword-1.0.7.fixed/abi/src/af/util/xp/ut_mbtowc.cpp	2005-03-05 01:59:15.000000000 -0800
@@ -219,7 +219,7 @@
 {
     UT_iconv_reset(cd);
     m_bufLen = 0;
-};
+}
 
 void UT_Mbtowc::setInCharset(const char* charset)
 {
@@ -229,33 +229,33 @@
 		UT_iconv_close(cd);
 
     cd = UT_iconv_open("UCS-2", charset );
-};
+}
 
 UT_Mbtowc::UT_Mbtowc(const char* from_charset): m_bufLen(0)
 {
     cd = UT_iconv_open("UCS-2", from_charset);
     UT_ASSERT(UT_iconv_isValid(cd));
-};
+}
 
 UT_Mbtowc::UT_Mbtowc(): m_bufLen(0)
 {
     cd = UT_iconv_open("UCS-2", XAP_EncodingManager::get_instance()->getNative8BitEncodingName() );
     UT_ASSERT(UT_iconv_isValid(cd)); 
-};
+}
 
 UT_Mbtowc::UT_Mbtowc(const UT_Mbtowc& v): m_bufLen(0)
 {
 	// Shouldn't a copy also copy the encoding?
     cd = UT_iconv_open("UCS-2", XAP_EncodingManager::get_instance()->getNative8BitEncodingName() );
     UT_ASSERT(UT_iconv_isValid(cd));
-};
+}
 
 UT_Mbtowc::~UT_Mbtowc()
 {
     /* libiconv is stupid - we'll get segfault if we don't check  - VH */
   if (UT_iconv_isValid(cd))
 	    UT_iconv_close(cd);
-};
+}
 
 int UT_Mbtowc::mbtowc(wchar_t &wc,char mb)
 {
@@ -286,6 +286,6 @@
 	    return 0;
 	}
     }
-};
+}
 
 #endif /* big if 0 */
diff -ur abiword-1.0.7/abi/src/af/util/xp/ut_string.cpp abiword-1.0.7.fixed/abi/src/af/util/xp/ut_string.cpp
--- abiword-1.0.7/abi/src/af/util/xp/ut_string.cpp	2002-04-28 17:52:28.000000000 -0700
+++ abiword-1.0.7.fixed/abi/src/af/util/xp/ut_string.cpp	2005-03-05 02:00:06.000000000 -0800
@@ -1025,7 +1025,7 @@
         return true;
     return false;
 #endif
-};
+}
 
 bool UT_UCS_islower(UT_UCSChar c)
 {
@@ -1043,7 +1043,7 @@
         return true;
     return false;
 #endif
-};
+}
 
 bool UT_UCS_isspace(UT_UCSChar c)
 {
@@ -1058,7 +1058,7 @@
 		return false;
 	}
 	return false;
-};
+}
 
 /*
 	TODO: proper Unicode implementation required
@@ -1083,7 +1083,7 @@
 		isalpha(local)!=0 : 
 		local > 0xff /* we consider it alpha if it's > 0xff */;
 #endif
-};
+}
 
 bool UT_UCS_isSentenceSeparator(UT_UCSChar c)
 {
@@ -1112,7 +1112,7 @@
 	sprintf(string,"%d.%d", i,fr);
   };
   return string;
-};
+}
 
 #ifdef BIDI_ENABLED
 /* copies exactly n-chars from src to dest; NB! does not check for 00 i src
diff -ur abiword-1.0.7/abi/src/af/util/xp/ut_wctomb.cpp abiword-1.0.7.fixed/abi/src/af/util/xp/ut_wctomb.cpp
--- abiword-1.0.7/abi/src/af/util/xp/ut_wctomb.cpp	2001-08-10 11:32:38.000000000 -0700
+++ abiword-1.0.7.fixed/abi/src/af/util/xp/ut_wctomb.cpp	2005-03-05 02:04:13.000000000 -0800
@@ -156,40 +156,40 @@
 void UT_Wctomb::initialize()
 {
     UT_iconv_reset(cd);
-};
+}
 
 void UT_Wctomb::setOutCharset(const char* charset)
 {
     UT_iconv_close(cd);
     cd = UT_iconv_open(charset,"UCS-2");
     //UT_ASSERT(cd!=(iconv_t)-1); //it's better to return "?" instead of crashing
-};
+}
 
 UT_Wctomb::UT_Wctomb(const char* to_charset)
 {
     cd = UT_iconv_open(to_charset,"UCS-2");
     //UT_ASSERT(cd!=(iconv_t)-1); //it's better to return "?" instead of crashing
-};
+}
 
 UT_Wctomb::UT_Wctomb()
 {
     cd = UT_iconv_open(XAP_EncodingManager::get_instance()->getNative8BitEncodingName(),"UCS-2");
     UT_ASSERT(UT_iconv_isValid(cd));
-};
+}
 
 UT_Wctomb::UT_Wctomb(const UT_Wctomb& v)
 {
 	// Shouldn't a copy also copy the encoding?
     cd = UT_iconv_open(XAP_EncodingManager::get_instance()->getNative8BitEncodingName(),"UCS-2");
     UT_ASSERT(UT_iconv_isValid(cd));
-};
+}
 
 UT_Wctomb::~UT_Wctomb()
 {
     /*libiconv is stupid - we'll get segfault if we don't check  - VH */
     if (UT_iconv_isValid(cd))
 	    UT_iconv_close(cd);
-};
+}
 
 int UT_Wctomb::wctomb(char * pC,int &length,wchar_t wc)
 {
@@ -209,7 +209,7 @@
 	return 0;
     length = 100-outlen;
     return 1;
-};
+}
 
 void UT_Wctomb::wctomb_or_fallback(char * pC,int &length,wchar_t wc)
 {
@@ -217,6 +217,6 @@
 	pC[0]='?';
 	length=1;
     };
-};
+}
 
 #endif
diff -ur abiword-1.0.7/abi/src/af/xap/unix/xap_UnixEncodingManager.cpp abiword-1.0.7.fixed/abi/src/af/xap/unix/xap_UnixEncodingManager.cpp
--- abiword-1.0.7/abi/src/af/xap/unix/xap_UnixEncodingManager.cpp	2003-01-24 21:10:03.000000000 -0800
+++ abiword-1.0.7.fixed/abi/src/af/xap/unix/xap_UnixEncodingManager.cpp	2005-03-05 11:04:55.000000000 -0800
@@ -544,6 +544,6 @@
 	};	
 	XAP_EncodingManager::initialize();
 	describe();
-};
+}
 
 
diff -ur abiword-1.0.7/abi/src/af/xap/unix/xap_UnixFont.cpp abiword-1.0.7.fixed/abi/src/af/xap/unix/xap_UnixFont.cpp
--- abiword-1.0.7/abi/src/af/xap/unix/xap_UnixFont.cpp	2002-07-31 15:35:21.000000000 -0700
+++ abiword-1.0.7.fixed/abi/src/af/xap/unix/xap_UnixFont.cpp	2005-03-05 14:05:46.000000000 -0800
@@ -565,7 +565,7 @@
 	
 	fclose(ef);
 	return m_pEncodingTable;
-};
+}
 
 bool XAP_UnixFont::_createPsSupportFiles()
 {
@@ -702,7 +702,10 @@
 	{
 		//UT_DEBUGMSG(("Found afm file for the font\n"));
 		// call down to the Adobe code
+		/* DISABLED: Where is abi_parseFile?
 		int result = abi_parseFile(fp, &m_metricsData, P_GM);
+		 */
+		int result = parseFileRes_parseError;
 		switch (result)
 		{
 			case parseFileRes_parseError:
diff -ur abiword-1.0.7/abi/src/af/xap/unix/xap_UnixNullGraphics.cpp abiword-1.0.7.fixed/abi/src/af/xap/unix/xap_UnixNullGraphics.cpp
--- abiword-1.0.7/abi/src/af/xap/unix/xap_UnixNullGraphics.cpp	2002-04-07 22:53:56.000000000 -0700
+++ abiword-1.0.7.fixed/abi/src/af/xap/unix/xap_UnixNullGraphics.cpp	2005-03-05 02:37:36.000000000 -0800
@@ -156,13 +156,6 @@
   GlobalFontInfo * gfi = pEnglishFont->getMetricsData()->gfi;
   UT_ASSERT(gfi);
 
-//#if 0
-//  e = _scaleFont(psfnt, gfi->ascender);
-  //#if 0
-  //  e = _scaleFont(psfnt, gfi->fontBBox.ury);
-  //#endif
-    
-
   XAP_UnixFont * pUFont = psfnt->getUnixFont();
   UT_sint32 iSize = psfnt->getSize();
   if(pUFont->isSizeInCache(iSize))
@@ -582,7 +575,7 @@
   m_vecFontList.addItem((void *) p);
   p->setIndex(m_vecFontList.getItemCount() - 1);
   return p;
-};
+}
 
 void UnixNull_Graphics::_explodePSFonts(PSFont *current, PSFont*& pEnglishFont,PSFont*& pChineseFont)
 {
diff -ur abiword-1.0.7/abi/src/af/xap/unix/xap_UnixPSGraphics.cpp abiword-1.0.7.fixed/abi/src/af/xap/unix/xap_UnixPSGraphics.cpp
--- abiword-1.0.7/abi/src/af/xap/unix/xap_UnixPSGraphics.cpp	2002-06-06 14:33:31.000000000 -0700
+++ abiword-1.0.7.fixed/abi/src/af/xap/unix/xap_UnixPSGraphics.cpp	2005-03-05 11:03:58.000000000 -0800
@@ -1774,7 +1774,7 @@
   m_vecFontList.addItem((void *) p);
   p->setIndex(m_vecFontList.getItemCount() - 1);
   return p;
-};
+}
 
 void PS_Graphics::_emit_SetFont(PSFont *pFont)
 {
@@ -1784,7 +1784,7 @@
       g_snprintf(buf, 1024, "F%d\n", pFont->getIndex());
       m_ps->writeBytes(buf);
     }
-};
+}
 
 
 
diff -ur abiword-1.0.7/abi/src/af/xap/unix/xap_UnixPSParseAFM.h abiword-1.0.7.fixed/abi/src/af/xap/unix/xap_UnixPSParseAFM.h
--- abiword-1.0.7/abi/src/af/xap/unix/xap_UnixPSParseAFM.h	2002-04-19 08:49:07.000000000 -0700
+++ abiword-1.0.7.fixed/abi/src/af/xap/unix/xap_UnixPSParseAFM.h	2005-03-05 01:54:45.000000000 -0800
@@ -340,12 +340,12 @@
  *
  *  The possible return codes from parseFile are defined above.
  */
-#ifdef __cplusplus
+/*#ifdef __cplusplus
 extern "C" {
-#endif
+#endif*/
   extern int abi_parseFile (FILE *fp, ABIFontInfo **fi, FLAGS flags); 
-#ifdef __cplusplus
+/*#ifdef __cplusplus
 };
-#endif
+#endif*/
 
 #endif /* XAP_UNIXPSPARSEAFM_H */
diff -ur abiword-1.0.7/abi/src/af/xap/xp/xap_App.cpp abiword-1.0.7.fixed/abi/src/af/xap/xp/xap_App.cpp
--- abiword-1.0.7/abi/src/af/xap/xp/xap_App.cpp	2002-04-24 06:44:48.000000000 -0700
+++ abiword-1.0.7.fixed/abi/src/af/xap/xp/xap_App.cpp	2005-03-05 02:13:18.000000000 -0800
@@ -133,7 +133,7 @@
 const XAP_EncodingManager* XAP_App::getEncodingManager() const 
 { 
     return XAP_EncodingManager::get_instance();
-};
+}
 
 EV_Menu_ActionSet *XAP_App::getMenuActionSet()
 {
diff -ur abiword-1.0.7/abi/src/af/xap/xp/xap_EncodingManager.cpp abiword-1.0.7.fixed/abi/src/af/xap/xp/xap_EncodingManager.cpp
--- abiword-1.0.7/abi/src/af/xap/xp/xap_EncodingManager.cpp	2002-02-22 23:22:35.000000000 -0800
+++ abiword-1.0.7.fixed/abi/src/af/xap/xp/xap_EncodingManager.cpp	2005-03-05 12:48:55.000000000 -0800
@@ -133,12 +133,12 @@
 const char* XAP_EncodingManager::getLanguageISOName() const 
 {
     return "en";
-};
+}
 
 const char* XAP_EncodingManager::getLanguageISOTerritory() const
 {
     return NULL;
-};
+}
 
 // TODO Do we need an equivalent function which can return
 // TODO U+FFFD "REPLACEMENT CHARACTER" or U+25A0 "BLACK SQUARE"
@@ -173,13 +173,13 @@
 		*/
 	}
 	return 0;
-};
+}
 
 UT_UCSChar XAP_EncodingManager::nativeToU(UT_UCSChar c) const
 {
     UT_UCSChar ret = try_nativeToU(c);
     return ret ? ret : fallbackChar(c);	
-};
+}
 
 UT_UCSChar XAP_EncodingManager::UToNative(UT_UCSChar c)  const
 {
@@ -192,27 +192,27 @@
     }
     else
     	return ret;
-};
+}
 
 UT_UCSChar XAP_EncodingManager::WindowsToU(UT_UCSChar c) const
 {
     UT_UCSChar ret = try_WindowsToU(c);
     return ret ? ret : fallbackChar(c);	
-};
+}
 
 
 UT_UCSChar XAP_EncodingManager::UToWindows(UT_UCSChar c)  const
 {
     UT_UCSChar ret = try_UToWindows(c);
     return ret && ret<=0xff ? ret : fallbackChar(c);	
-};
+}
 
 
 const char* XAP_EncodingManager::strToNative(const char* in,const char* charset,bool bUseSysEncoding) const
 {
 	static char buf[500];
 	return strToNative(in, charset, buf, sizeof(buf), bUseSysEncoding);
-};
+}
 
 const char* XAP_EncodingManager::strToNative(const char* in, const char* charset, char* buf, int bufsz,
 											 bool bUseSysEncoding) const
@@ -253,7 +253,7 @@
 
 	UT_iconv_close(iconv_handle);
 	return retstr;
-};
+}
 
 int XAP_EncodingManager::XAP_XML_UnknownEncodingHandler(void* /*encodingHandlerData*/,
                                           const XML_Char *name,
@@ -295,7 +295,7 @@
 	UT_iconv_close(iconv_handle);
 	return 1;
 #endif
-};
+}
 
 extern "C" { char *wvLIDToCodePageConverter(unsigned short lid); }
 static void init_values(const XAP_EncodingManager* that)
@@ -307,7 +307,7 @@
 	char* winencname = wvLIDToCodePageConverter(that->getWinLanguageCode());
 	iconv_handle_Win2U = UT_iconv_open("UCS-2",winencname);
 	iconv_handle_U2Win = UT_iconv_open(winencname,"UCS-2");
-};
+}
 
 
 static UT_UCSChar try_CToU(UT_UCSChar c,UT_iconv_t iconv_handle)
@@ -334,7 +334,7 @@
 		return uval;
 	} else
 		return  0;
-};
+}
 
 static UT_UCSChar try_UToC(UT_UCSChar c,UT_iconv_t iconv_handle)
 {
@@ -361,22 +361,22 @@
 			return (unsigned char)*obuf;
 	} else
 		return  0;
-};
+}
 
 UT_UCSChar XAP_EncodingManager::try_nativeToU(UT_UCSChar c) const
 {
 	return try_CToU(c,iconv_handle_N2U);
-};
+}
 
 UT_UCSChar XAP_EncodingManager::try_UToNative(UT_UCSChar c)  const
 {
 	return try_UToC(c,iconv_handle_U2N);
-};
+}
 
 UT_UCSChar XAP_EncodingManager::try_UToLatin1(UT_UCSChar c)  const
 {
 	return try_UToC(c,iconv_handle_U2Latin1);
-};
+}
 
 UT_UCSChar XAP_EncodingManager::try_WindowsToU(UT_UCSChar c) const 
 { 
@@ -417,7 +417,7 @@
 	if (is_default)	
 		*is_default = true;
 	return m->value;
-};
+}
 
 static const char* search_rmap_with_opt_suffix(const _rmap* m,const char* key,const char* fallback_key=NULL,const char* fallback_key_final=NULL)
 {
@@ -426,7 +426,7 @@
 	if (!is_default || !fallback_key)
 		return value;
 	return search_rmap_with_opt_suffix(m,fallback_key,fallback_key_final);
-};
+}
 
 
 struct _map
@@ -445,7 +445,7 @@
 	if (is_default)
 		*is_default = true;
 	return m->value;
-};
+}
 
 static const char* search_map_with_opt_suffix(const _map* m,const char* key,const char* fallback_key=NULL,const char* fallback_key_final=NULL)
 {
@@ -454,7 +454,7 @@
 	if (!is_default || !fallback_key)
 		return value;
 	return search_map_with_opt_suffix(m,fallback_key,fallback_key_final);
-};
+}
 
 /* ************************* here begin tables *************************/
 
@@ -821,7 +821,7 @@
 		if (!UT_stricmp(cur->fields[idx],key))
 			return cur;
 	return NULL;
-};
+}
 
 bool XAP_EncodingManager::swap_utos = 0;
 bool XAP_EncodingManager::swap_stou = 0;
@@ -973,7 +973,7 @@
 bool XAP_EncodingManager::can_break_words() const
 {
     return can_break_words_;
-};
+}
 
 /*
     I'm not sure whether any non-cjk language doesn't make distinction
@@ -987,7 +987,7 @@
     if (!cjk_locale())
 	return 0;
     return (c>0xff);
-};
+}
 
 bool XAP_EncodingManager::noncjk_letters(const UT_UCSChar* str,int len) const
 {
@@ -998,7 +998,7 @@
 	    return 0;
     };
     return 1;
-};
+}
 
 /*
     This one correlates with can_break_words() very tightly.
@@ -1014,13 +1014,13 @@
 	 || c == UCS_EM_DASH)
 	return 1;
     return is_cjk_letter(c);
-};
+}
 
 
 const char* XAP_EncodingManager::getTexPrologue() const
 {
     return TexPrologue;
-};
+}
 
 // Warning:
 // This code forces us to use "GB2312", "BIG5", etc instead
@@ -1035,7 +1035,7 @@
     bool is_default;
     const char* ret = search_map(MSCodepagename_to_charset_name_map,cpname,&is_default);
     return is_default ? cpname : ret;
-};
+}
 
 const char* XAP_EncodingManager::CodepageFromCharset(char *charset) const
 {
@@ -1051,17 +1051,17 @@
     bool is_default;
     const char* ret = search_map(MSCodepagename_to_charset_name_map,cpname,&is_default);
     return is_default ? cpname : ret;
-};
+}
 
 UT_uint32  XAP_EncodingManager::getWinLanguageCode() const
 {
 	return WinLanguageCode;
-};
+}
 
 UT_uint32  XAP_EncodingManager::getWinCharsetCode() const
 {
 	return WinCharsetCode;
-};
+}
 
 void 	XAP_EncodingManager::describe()
 {
@@ -1083,7 +1083,7 @@
 		int(cjk_locale()), int(can_break_words()),int(swap_utos),int(swap_stou)
 		));
 	UT_ASSERT( UT_iconv_isValid(iconv_handle_N2U) && UT_iconv_isValid(iconv_handle_U2N) );
-};
+}
 
 
 /*
@@ -1148,7 +1148,7 @@
 	//_DEBUGMSG(("combinations: %s, %s, %s, %s, %s\n", ptrs[0], ptrs[1],ptrs[2],ptrs[3],ptrs[4]));
 	
     return ptrs;
-};
+}
 
 /* pspell hack */
 extern "C" {
diff -ur abiword-1.0.7/abi/src/af/xap/xp/xav_View.cpp abiword-1.0.7.fixed/abi/src/af/xap/xp/xav_View.cpp
--- abiword-1.0.7/abi/src/af/xap/xp/xav_View.cpp	2002-05-02 18:49:21.000000000 -0700
+++ abiword-1.0.7.fixed/abi/src/af/xap/xp/xav_View.cpp	2005-03-05 02:19:06.000000000 -0800
@@ -171,7 +171,7 @@
 	m_bInsertMode = bInsert; 
 
 	notifyListeners(AV_CHG_INSERTMODE); 
-};
+}
 
 void AV_View::setWindowSize(UT_sint32 width, UT_sint32 height)
 {
diff -ur abiword-1.0.7/abi/src/text/fmt/xp/fl_DocLayout.h abiword-1.0.7.fixed/abi/src/text/fmt/xp/fl_DocLayout.h
--- abiword-1.0.7/abi/src/text/fmt/xp/fl_DocLayout.h	2002-02-02 04:23:35.000000000 -0800
+++ abiword-1.0.7.fixed/abi/src/text/fmt/xp/fl_DocLayout.h	2005-03-05 11:37:12.000000000 -0800
@@ -191,10 +191,10 @@
 
 	void		__dump(FILE * fp) const;
 #endif
+	void				_toggleAutoSpell(bool bSpell);
 	
 protected:
 	static void			_backgroundCheck(UT_Worker * pTimer);
-	void				_toggleAutoSpell(bool bSpell);
 	void				_toggleAutoSmartQuotes(bool bSQ);
 	
 	static void			_prefsListener(class XAP_App *, class XAP_Prefs *, 
diff -ur abiword-1.0.7/abi/src/text/fmt/xp/fv_View.cpp abiword-1.0.7.fixed/abi/src/text/fmt/xp/fv_View.cpp
--- abiword-1.0.7/abi/src/text/fmt/xp/fv_View.cpp	2003-08-30 21:36:51.000000000 -0700
+++ abiword-1.0.7.fixed/abi/src/text/fmt/xp/fv_View.cpp	2005-03-05 11:05:34.000000000 -0800
@@ -10755,7 +10755,7 @@
 		    draw();
 		}
 	}
-};
+}
 
 
 /*!
diff -ur abiword-1.0.7/abi/src/wp/ap/unix/abiwidget.cpp abiword-1.0.7.fixed/abi/src/wp/ap/unix/abiwidget.cpp
--- abiword-1.0.7/abi/src/wp/ap/unix/abiwidget.cpp	2002-05-14 00:44:29.000000000 -0700
+++ abiword-1.0.7.fixed/abi/src/wp/ap/unix/abiwidget.cpp	2005-03-05 12:51:07.000000000 -0800
@@ -230,7 +230,7 @@
 static gboolean EM_NAME(n) (AbiWidget * w, const char * str) \
 { \
 return abi_widget_invoke_ex (w, #n, str, 0, 0); \
-}
+} 
 
 /**************************************************************************/
 /**************************************************************************/
@@ -238,104 +238,104 @@
 // Here we define our EditMethods which will later be mapped back onto
 // Our AbiWidgetClass' member functions
 
-EM_VOID__BOOL(alignCenter);
-EM_VOID__BOOL(alignLeft);
-EM_VOID__BOOL(alignRight);
-EM_VOID__BOOL(alignJustify);
-
-EM_VOID__BOOL(copy);
-EM_VOID__BOOL(cut);
-EM_VOID__BOOL(paste);
-EM_VOID__BOOL(pasteSpecial);
-EM_VOID__BOOL(selectAll);
-EM_VOID__BOOL(selectBlock);
-EM_VOID__BOOL(selectLine);
-EM_VOID__BOOL(selectWord);
-
-EM_VOID__BOOL(undo);
-EM_VOID__BOOL(redo);
-
-EM_CHARPTR__BOOL(insertData);
-EM_VOID__BOOL(insertSpace);
-
-EM_VOID__BOOL(delBOB);
-EM_VOID__BOOL(delBOD);
-EM_VOID__BOOL(delBOL);
-EM_VOID__BOOL(delBOW);
-EM_VOID__BOOL(delEOB);
-EM_VOID__BOOL(delEOD);
-EM_VOID__BOOL(delEOL);
-EM_VOID__BOOL(delEOW);
-EM_VOID__BOOL(delLeft);
-EM_VOID__BOOL(delRight);
-
-EM_VOID__BOOL(editHeader);
-EM_VOID__BOOL(editFooter);
-EM_VOID__BOOL(removeHeader);
-EM_VOID__BOOL(removeFooter);
-
-EM_VOID__BOOL(extSelBOB);
-EM_VOID__BOOL(extSelBOD);
-EM_VOID__BOOL(extSelBOL);
-EM_VOID__BOOL(extSelBOW);
-EM_VOID__BOOL(extSelEOB);
-EM_VOID__BOOL(extSelEOD);
-EM_VOID__BOOL(extSelEOL);
-EM_VOID__BOOL(extSelEOW);
-EM_VOID__BOOL(extSelLeft);
-EM_VOID__BOOL(extSelNextLine);
-EM_VOID__BOOL(extSelPageDown);
-EM_VOID__BOOL(extSelPageUp);
-EM_VOID__BOOL(extSelPrevLine);
-EM_VOID__BOOL(extSelRight);
-EM_VOID__BOOL(extSelScreenDown);
-EM_VOID__BOOL(extSelScreenUp);
-EM_INT_INT__BOOL(extSelToXY);
-
-EM_VOID__BOOL(toggleBold);
-EM_VOID__BOOL(toggleBottomline);
-EM_VOID__BOOL(toggleInsertMode);
-EM_VOID__BOOL(toggleItalic);
-EM_VOID__BOOL(toggleOline);
-EM_VOID__BOOL(togglePlain);
-EM_VOID__BOOL(toggleStrike);
-EM_VOID__BOOL(toggleSub);
-EM_VOID__BOOL(toggleSuper);
-EM_VOID__BOOL(toggleTopline);
-EM_VOID__BOOL(toggleUline);
-EM_VOID__BOOL(toggleUnIndent);
-
-EM_VOID__BOOL(viewPara);
-EM_VOID__BOOL(viewPrintLayout);
-EM_VOID__BOOL(viewNormalLayout);
-EM_VOID__BOOL(viewWebLayout);
-
-EM_VOID__BOOL(warpInsPtBOB);
-EM_VOID__BOOL(warpInsPtBOD);
-EM_VOID__BOOL(warpInsPtBOL);
-EM_VOID__BOOL(warpInsPtBOP);
-EM_VOID__BOOL(warpInsPtBOW);
-EM_VOID__BOOL(warpInsPtEOB);
-EM_VOID__BOOL(warpInsPtEOD);
-EM_VOID__BOOL(warpInsPtEOL);
-EM_VOID__BOOL(warpInsPtEOP);
-EM_VOID__BOOL(warpInsPtEOW);
-EM_VOID__BOOL(warpInsPtLeft);
-EM_VOID__BOOL(warpInsPtNextLine);
-EM_VOID__BOOL(warpInsPtNextPage);
-EM_VOID__BOOL(warpInsPtNextScreen);
-EM_VOID__BOOL(warpInsPtPrevLine);
-EM_VOID__BOOL(warpInsPtPrevPage);
-EM_VOID__BOOL(warpInsPtPrevScreen);
-EM_VOID__BOOL(warpInsPtRight);
-EM_INT_INT__BOOL(warpInsPtToXY);
-
-EM_VOID__BOOL(zoom100);
-EM_VOID__BOOL(zoom200);
-EM_VOID__BOOL(zoom50);
-EM_VOID__BOOL(zoom75);
-EM_VOID__BOOL(zoomWhole);
-EM_VOID__BOOL(zoomWidth);
+EM_VOID__BOOL(alignCenter)
+EM_VOID__BOOL(alignLeft)
+EM_VOID__BOOL(alignRight)
+EM_VOID__BOOL(alignJustify)
+
+EM_VOID__BOOL(copy)
+EM_VOID__BOOL(cut)
+EM_VOID__BOOL(paste)
+EM_VOID__BOOL(pasteSpecial)
+EM_VOID__BOOL(selectAll)
+EM_VOID__BOOL(selectBlock)
+EM_VOID__BOOL(selectLine)
+EM_VOID__BOOL(selectWord)
+
+EM_VOID__BOOL(undo)
+EM_VOID__BOOL(redo)
+
+EM_CHARPTR__BOOL(insertData)
+EM_VOID__BOOL(insertSpace)
+
+EM_VOID__BOOL(delBOB)
+EM_VOID__BOOL(delBOD)
+EM_VOID__BOOL(delBOL)
+EM_VOID__BOOL(delBOW)
+EM_VOID__BOOL(delEOB)
+EM_VOID__BOOL(delEOD)
+EM_VOID__BOOL(delEOL)
+EM_VOID__BOOL(delEOW)
+EM_VOID__BOOL(delLeft)
+EM_VOID__BOOL(delRight)
+
+EM_VOID__BOOL(editHeader)
+EM_VOID__BOOL(editFooter)
+EM_VOID__BOOL(removeHeader)
+EM_VOID__BOOL(removeFooter)
+
+EM_VOID__BOOL(extSelBOB)
+EM_VOID__BOOL(extSelBOD)
+EM_VOID__BOOL(extSelBOL)
+EM_VOID__BOOL(extSelBOW)
+EM_VOID__BOOL(extSelEOB)
+EM_VOID__BOOL(extSelEOD)
+EM_VOID__BOOL(extSelEOL)
+EM_VOID__BOOL(extSelEOW)
+EM_VOID__BOOL(extSelLeft)
+EM_VOID__BOOL(extSelNextLine)
+EM_VOID__BOOL(extSelPageDown)
+EM_VOID__BOOL(extSelPageUp)
+EM_VOID__BOOL(extSelPrevLine)
+EM_VOID__BOOL(extSelRight)
+EM_VOID__BOOL(extSelScreenDown)
+EM_VOID__BOOL(extSelScreenUp)
+EM_INT_INT__BOOL(extSelToXY)
+
+EM_VOID__BOOL(toggleBold)
+EM_VOID__BOOL(toggleBottomline)
+EM_VOID__BOOL(toggleInsertMode)
+EM_VOID__BOOL(toggleItalic)
+EM_VOID__BOOL(toggleOline)
+EM_VOID__BOOL(togglePlain)
+EM_VOID__BOOL(toggleStrike)
+EM_VOID__BOOL(toggleSub)
+EM_VOID__BOOL(toggleSuper)
+EM_VOID__BOOL(toggleTopline)
+EM_VOID__BOOL(toggleUline)
+EM_VOID__BOOL(toggleUnIndent)
+
+EM_VOID__BOOL(viewPara)
+EM_VOID__BOOL(viewPrintLayout)
+EM_VOID__BOOL(viewNormalLayout)
+EM_VOID__BOOL(viewWebLayout)
+
+EM_VOID__BOOL(warpInsPtBOB)
+EM_VOID__BOOL(warpInsPtBOD)
+EM_VOID__BOOL(warpInsPtBOL)
+EM_VOID__BOOL(warpInsPtBOP)
+EM_VOID__BOOL(warpInsPtBOW)
+EM_VOID__BOOL(warpInsPtEOB)
+EM_VOID__BOOL(warpInsPtEOD)
+EM_VOID__BOOL(warpInsPtEOL)
+EM_VOID__BOOL(warpInsPtEOP)
+EM_VOID__BOOL(warpInsPtEOW)
+EM_VOID__BOOL(warpInsPtLeft)
+EM_VOID__BOOL(warpInsPtNextLine)
+EM_VOID__BOOL(warpInsPtNextPage)
+EM_VOID__BOOL(warpInsPtNextScreen)
+EM_VOID__BOOL(warpInsPtPrevLine)
+EM_VOID__BOOL(warpInsPtPrevPage)
+EM_VOID__BOOL(warpInsPtPrevScreen)
+EM_VOID__BOOL(warpInsPtRight)
+EM_INT_INT__BOOL(warpInsPtToXY)
+
+EM_VOID__BOOL(zoom100)
+EM_VOID__BOOL(zoom200)
+EM_VOID__BOOL(zoom50)
+EM_VOID__BOOL(zoom75)
+EM_VOID__BOOL(zoomWhole)
+EM_VOID__BOOL(zoomWidth)
 
 /**************************************************************************/
 /**************************************************************************/
diff -ur abiword-1.0.7/abi/src/wp/ap/unix/ap_UnixDialog_Options.cpp abiword-1.0.7.fixed/abi/src/wp/ap/unix/ap_UnixDialog_Options.cpp
--- abiword-1.0.7/abi/src/wp/ap/unix/ap_UnixDialog_Options.cpp	2002-04-12 02:49:41.000000000 -0700
+++ abiword-1.0.7.fixed/abi/src/wp/ap/unix/ap_UnixDialog_Options.cpp	2005-03-05 13:02:14.000000000 -0800
@@ -1376,9 +1376,9 @@
         gtk_clist_set_row_data (GTK_CLIST (m_toolbarClist), row, GINT_TO_POINTER(b)); \
 }
 
-DEFINE_CLIST_GET_SET_BOOL(ViewShowStandardBar, 0);
-DEFINE_CLIST_GET_SET_BOOL(ViewShowFormatBar, 1);
-DEFINE_CLIST_GET_SET_BOOL(ViewShowExtraBar, 2);
+DEFINE_CLIST_GET_SET_BOOL(ViewShowStandardBar, 0)
+DEFINE_CLIST_GET_SET_BOOL(ViewShowFormatBar, 1)
+DEFINE_CLIST_GET_SET_BOOL(ViewShowExtraBar, 2)
 #undef DEFINE_CLIST_GET_SET_BOOL
 
 
@@ -1404,27 +1404,27 @@
 	gtk_editable_insert_text(GTK_EDITABLE(m_text##widget), t, strlen(t), &pos);	\
 }
  
-DEFINE_GET_SET_BOOL(SpellCheckAsType);
-DEFINE_GET_SET_BOOL(SpellHideErrors);
-DEFINE_GET_SET_BOOL(SpellSuggest);
-DEFINE_GET_SET_BOOL(SpellMainOnly);
-DEFINE_GET_SET_BOOL(SpellUppercase);
-DEFINE_GET_SET_BOOL(SpellNumbers);
-DEFINE_GET_SET_BOOL(SpellInternet);
-DEFINE_GET_SET_BOOL(SmartQuotesEnable);
+DEFINE_GET_SET_BOOL(SpellCheckAsType)
+DEFINE_GET_SET_BOOL(SpellHideErrors)
+DEFINE_GET_SET_BOOL(SpellSuggest)
+DEFINE_GET_SET_BOOL(SpellMainOnly)
+DEFINE_GET_SET_BOOL(SpellUppercase)
+DEFINE_GET_SET_BOOL(SpellNumbers)
+DEFINE_GET_SET_BOOL(SpellInternet)
+DEFINE_GET_SET_BOOL(SmartQuotesEnable)
 
 #ifdef BIDI_ENABLED
-DEFINE_GET_SET_BOOL(OtherDirectionRtl);
-DEFINE_GET_SET_BOOL(OtherUseContextGlyphs);
-DEFINE_GET_SET_BOOL(OtherSaveContextGlyphs);
-DEFINE_GET_SET_BOOL(OtherHebrewContextGlyphs);
+DEFINE_GET_SET_BOOL(OtherDirectionRtl)
+DEFINE_GET_SET_BOOL(OtherUseContextGlyphs)
+DEFINE_GET_SET_BOOL(OtherSaveContextGlyphs)
+DEFINE_GET_SET_BOOL(OtherHebrewContextGlyphs)
 #endif
 
-DEFINE_GET_SET_BOOL(AutoSaveFile);
-DEFINE_GET_SET_BOOL(ShowSplash);
-DEFINE_GET_SET_BOOL(PrefsAutoSave);
-DEFINE_GET_SET_BOOL(ViewShowRuler);
-DEFINE_GET_SET_BOOL(ViewShowStatusBar);
+DEFINE_GET_SET_BOOL(AutoSaveFile)
+DEFINE_GET_SET_BOOL(ShowSplash)
+DEFINE_GET_SET_BOOL(PrefsAutoSave)
+DEFINE_GET_SET_BOOL(ViewShowRuler)
+DEFINE_GET_SET_BOOL(ViewShowStatusBar)
 
 void AP_UnixDialog_Options::_gatherAutoSaveFileExt(UT_String &stRetVal)
 {
@@ -1544,13 +1544,13 @@
 	int r = option_menu_set_by_key ( m_listViewRulerUnits, (gpointer)dim, WIDGET_MENU_VALUE_TAG ); 
 }
 
-DEFINE_GET_SET_BOOL	(ViewCursorBlink);
+DEFINE_GET_SET_BOOL	(ViewCursorBlink)
 
-DEFINE_GET_SET_BOOL	(ViewAll);
-DEFINE_GET_SET_BOOL	(ViewHiddenText);
-DEFINE_GET_SET_BOOL	(ViewUnprintable);
-DEFINE_GET_SET_BOOL (AllowCustomToolbars);
-DEFINE_GET_SET_BOOL (AutoLoadPlugins);
+DEFINE_GET_SET_BOOL	(ViewAll)
+DEFINE_GET_SET_BOOL	(ViewHiddenText)
+DEFINE_GET_SET_BOOL	(ViewUnprintable)
+DEFINE_GET_SET_BOOL (AllowCustomToolbars)
+DEFINE_GET_SET_BOOL (AutoLoadPlugins)
 
 #undef DEFINE_GET_SET_BOOL
 
diff -ur abiword-1.0.7/abi/src/wp/ap/xp/ap_Ruler.cpp abiword-1.0.7.fixed/abi/src/wp/ap/xp/ap_Ruler.cpp
--- abiword-1.0.7/abi/src/wp/ap/xp/ap_Ruler.cpp	2001-04-21 21:08:48.000000000 -0700
+++ abiword-1.0.7.fixed/abi/src/wp/ap/xp/ap_Ruler.cpp	2005-03-05 11:58:19.000000000 -0800
@@ -106,7 +106,7 @@
 		UT_ASSERT(UT_NOT_IMPLEMENTED);
 		break;
 	}
-};
+}
 
 /*! 
     Snap pixel value to nearest grid line
diff -ur abiword-1.0.7/abi/src/wp/impexp/xp/ie_impGraphic_JPEG.h abiword-1.0.7.fixed/abi/src/wp/impexp/xp/ie_impGraphic_JPEG.h
--- abiword-1.0.7/abi/src/wp/impexp/xp/ie_impGraphic_JPEG.h	2002-02-25 08:11:42.000000000 -0800
+++ abiword-1.0.7.fixed/abi/src/wp/impexp/xp/ie_impGraphic_JPEG.h	2005-03-05 13:30:25.000000000 -0800
@@ -30,7 +30,7 @@
 extern "C" 
 {
 #include "jpeglib.h"
-};
+}
 
 
 #include "ie_impGraphic.h"
diff -ur abiword-1.0.7/abi/src/wp/impexp/xp/ie_imp_RTF.cpp abiword-1.0.7.fixed/abi/src/wp/impexp/xp/ie_imp_RTF.cpp
--- abiword-1.0.7/abi/src/wp/impexp/xp/ie_imp_RTF.cpp	2003-02-14 14:24:45.000000000 -0800
+++ abiword-1.0.7.fixed/abi/src/wp/impexp/xp/ie_imp_RTF.cpp	2005-03-05 13:39:45.000000000 -0800
@@ -853,11 +853,11 @@
 			,bm_dom_dir(false)
 #endif
 { 
-};                  
+}                  
 
 RTFProps_bParaProps::~RTFProps_bParaProps(void)
 { 
-};                  
+}                  
 
 
 
@@ -1077,11 +1077,11 @@
 	m_styleNumber = -1;
 	m_listTag = 0;
 	m_szLang = 0;
-};
+}
 
 RTFProps_CharProps::~RTFProps_CharProps(void)
 {
-};
+}
 
 // Paragraph properties
 RTFProps_ParaProps::RTFProps_ParaProps(void)
@@ -1111,7 +1111,7 @@
 #ifdef BIDI_ENABLED
 	m_dom_dir = FRIBIDI_TYPE_UNSET;
 #endif
-};                  
+}                  
 
 
 RTFProps_ParaProps& RTFProps_ParaProps::operator=(const RTFProps_ParaProps& other)
@@ -1196,7 +1196,7 @@
 	sizeType = ipstNone;
 	wGoal = hGoal = width = height = 0;
 	scaleX = scaleY = 100;
-};
+}
 
 
 RTFProps_SectionProps::RTFProps_SectionProps()
@@ -1215,7 +1215,7 @@
 #ifdef BIDI_ENABLED
 	m_dir = FRIBIDI_TYPE_UNSET;
 #endif
-};
+}
 
 RTFStateStore::RTFStateStore()
 {
diff -ur abiword-1.0.7/expat/expat_config.h abiword-1.0.7.fixed/expat/expat_config.h
--- abiword-1.0.7/expat/expat_config.h	2003-02-19 06:02:43.000000000 -0800
+++ abiword-1.0.7.fixed/expat/expat_config.h	2005-03-05 01:28:05.000000000 -0800
@@ -1,89 +1,90 @@
+/* expat_config.h.  Generated by configure.  */
 /* expat_config.h.in.  Generated from configure.in by autoheader.  */
 
 /* 1234 = LIL_ENDIAN, 4321 = BIGENDIAN */
-#undef BYTEORDER
+#define BYTEORDER 1234
 
 /* Define to 1 if you have the `bcopy' function. */
-#undef HAVE_BCOPY
+#define HAVE_BCOPY 1
 
 /* Define to 1 if you have the <dlfcn.h> header file. */
-#undef HAVE_DLFCN_H
+#define HAVE_DLFCN_H 1
 
 /* Define to 1 if you have the <fcntl.h> header file. */
 #define HAVE_FCNTL_H 1
 
 /* Define to 1 if you have the `getpagesize' function. */
-#undef HAVE_GETPAGESIZE
+#define HAVE_GETPAGESIZE 1
 
 /* Define to 1 if you have the <inttypes.h> header file. */
-#undef HAVE_INTTYPES_H
+#define HAVE_INTTYPES_H 1
 
 /* Define to 1 if you have the `memmove' function. */
 #define HAVE_MEMMOVE 1
 
 /* Define to 1 if you have the <memory.h> header file. */
-#undef HAVE_MEMORY_H
+#define HAVE_MEMORY_H 1
 
 /* Define to 1 if you have a working `mmap' system call. */
-#undef HAVE_MMAP
+#define HAVE_MMAP 1
 
 /* Define to 1 if you have the <stdint.h> header file. */
-#undef HAVE_STDINT_H
+#define HAVE_STDINT_H 1
 
 /* Define to 1 if you have the <stdlib.h> header file. */
-#undef HAVE_STDLIB_H
+#define HAVE_STDLIB_H 1
 
 /* Define to 1 if you have the <strings.h> header file. */
-#undef HAVE_STRINGS_H
+#define HAVE_STRINGS_H 1
 
 /* Define to 1 if you have the <string.h> header file. */
-#undef HAVE_STRING_H
+#define HAVE_STRING_H 1
 
 /* Define to 1 if you have the <sys/stat.h> header file. */
-#undef HAVE_SYS_STAT_H
+#define HAVE_SYS_STAT_H 1
 
 /* Define to 1 if you have the <sys/types.h> header file. */
-#undef HAVE_SYS_TYPES_H
+#define HAVE_SYS_TYPES_H 1
 
 /* Define to 1 if you have the <unistd.h> header file. */
-#undef HAVE_UNISTD_H
+#define HAVE_UNISTD_H 1
 
 /* Define to the address where bug reports for this package should be sent. */
-#undef PACKAGE_BUGREPORT
+#define PACKAGE_BUGREPORT "expat-bugs@mail.libexpat.org"
 
 /* Define to the full name of this package. */
-#undef PACKAGE_NAME
+#define PACKAGE_NAME "expat"
 
 /* Define to the full name and version of this package. */
-#undef PACKAGE_STRING
+#define PACKAGE_STRING "expat 1.95.6"
 
 /* Define to the one symbol short name of this package. */
-#undef PACKAGE_TARNAME
+#define PACKAGE_TARNAME "expat"
 
 /* Define to the version of this package. */
-#undef PACKAGE_VERSION
+#define PACKAGE_VERSION "1.95.6"
 
 /* Define to 1 if you have the ANSI C header files. */
 #define STDC_HEADERS 1
 
 /* whether byteorder is bigendian */
-#undef WORDS_BIGENDIAN
+/* #undef WORDS_BIGENDIAN */
 
 /* Define to specify how much context to retain around the current parse
    point. */
 #define XML_CONTEXT_BYTES 1024
 
 /* Define to make parameter entity parsing functionality available. */
-#define XML_DTD
+#define XML_DTD 1
 
 /* Define to make XML Namespaces functionality available. */
-#define XML_NS
+#define XML_NS 1
 
 /* Define to empty if `const' does not conform to ANSI C. */
-#undef const
+/* #undef const */
 
 /* Define to `long' if <sys/types.h> does not define. */
-#undef off_t
+/* #undef off_t */
 
 /* Define to `unsigned' if <sys/types.h> does not define. */
-#undef size_t
+/* #undef size_t */
